Repository navigation
Tracking issue for syn 1.0 #687
Description
Current prerelease: syn-next = "1.0.0-rc4"
Release notes in progress:
Syn is a library for parsing Rust code, largely geared toward use in procedural macros but generally applicable as a Rust parser outside of that too.
Syn was originally a sidequest on the effort to making Serde's derive macros work on stable Rust in 2016, but has since taken off as a foundational library in its own right. These days it appears in support of diverse use cases like:
- convenient interop between Rust-based Wasm modules and JavaScript,
- easy command line interfaces,
- a polished async experience, and
- a concurrency framework for embedded real time systems.
Excitingly, the fraction of open source Rust projects that rely on Syn is still climbing aggressively (see red line). This reflects how important procedural macros are to the experience we want people to have when working with Rust — empowering everyone to build reliable and efficient software.
This 1.0 release signifies that Syn is a polished and stable library and that it offers a user experience we can stand behind as the way we recommend for all Rustaceans to write procedural macros.
Be aware that the underlying Rust language will continue to evolve. Syn is able to accommodate most kinds of Rust grammar changes via the nonexhaustive enums and Verbatim variants in the syntax tree, but we will plan to put out new major versions on a 12 to 24 month cadence to incorporate ongoing language changes as needed.
Note: in combination with this release, please see also the release notes for quote 1.0 which resolves multiple longstanding limitations of the quote macro.
Breaking changes
- Minimum required Rust version is raised from rustc 1.15 to 1.31.
Items
-
The syntax tree for function signatures has been redesigned. The types
MethodSigandFnDeclhave been unified into one typeSignaturethat is common across all varieties of function signatures. -
The syntax tree for function arguments has been redesigned. The new type is
FnArgwhich represents one argument of a function, associated function, trait function, or foreign function. Arguments of closures are no longer treated asFnArgand are simply aPatinstead. -
The
Fieldstype now implements IntoIterator, in addition to the previously existing IntoIterator impls on &Fields and &mut Fields. This may require changing.into_iter()calls to.iter()when used on a value of type &Fields. -
The representation of
Item::Macro22.0-style declarative macros have been collapsed into a single token stream pending figuring out what the syntax should be in rust-lang/rust#39412. -
Item::ExistentialandImplItem::Existentialhave been removed in favor of RFC 2515.
Expressions
-
Expr::Awaitis a new variant of expression for postfix.awaitsyntax per ongoing work on rust-lang/rust#50547. -
Expr::InPlacehas been removed as a result of RFC 2387.
Types
BareFnArgNamehas been eliminated in favor ofIdentfor representing the arguments of aType::BareFn.
Patterns
-
Pat::Oris a new variant of pattern as specified by RFC 2535. -
Pat::Typeis a new variant of pattern for type ascription as specified by RFC 2522. -
Pat::Restis a new variant of pattern representing the..pattern as specified by RFC 2707. -
The
Pat::SliceandPat::Tuplepatterns have been redesigned to accomodate RFC 2359. -
Pat::Refhas been renamed toPat::Referenceto align withExpr::ReferenceandType::Reference.
Tokens
-
The
Lit::IntandLit::Floatliteral types have been redesigned to represent arbitrarily large numbers and arbitrary suffixes. Rather than.value(), there is a.base10_digits()accessor which the caller should parse into the appropriate representation. -
The types of the token representation of the
selfandSelftokens have been renamed fromSelf_/CapSelftoSelfValue/SelfTyperespectively. This does not affect you if you are referring to them asToken![self]andToken![Self]. -
The
Lit::Verbatimliteral escape hatch now holds aproc_macro2::Literalprimitive token directly, rather than the previousLitVerbatimwrapper.
Attributes
-
The
Attribute::interpret_metamethod is removed in favor ofAttribute::parse_metawhich produces a better error. -
The variants of
Metanow contain aPathrather than a singleIdentas specified by RFC 2103. -
Function parameters now hold attributes as specified by RFC 2565.
More
-
The argument of
Path::is_identis now taken by reference. The common case of using this method with a string literal will continue to work:path.is_ident("..."). -
The type returned by
Punctuated::into_iterno longer has aPtype parameter, as it only returns sequence elements without punctuation. -
The
first,last, andlast_mutaccessors ofPunctuatednow return the elementTonly, no longer a punctuated pair. The old paired behavior of.first()can be written as.pairs().next(),.last()can be written as.pairs().next_back(), and.last_mut()can be written as.pairs_mut().next_back(). -
Various uses of
ttsas a field name in the syntax tree have been renamed totokensto eliminate the nonstandard abbreviation.

Activity
dtolnay commentedon Aug 3, 2019
FYI @mystor @alexcrichton @SergioBenitez @sgrif.
The Syn changes are minor so it should be fine not to bother with the rc versions this time, but I figured I would give some advance notice. The quote changes are potentially interesting. Real release is scheduled for the week of August 12.
Centril commentedon Aug 3, 2019
The definition of
Metadoesn't seem to support rust-lang/rust#57367 (comment)? It would be good to have a translation fromAttributeto that grammar in some typed fashion.I would strongly recommend waiting for
#[non_exhaustive]in some form to enable a more well typed gradual incorporation of language changes.dtolnay commentedon Aug 3, 2019
Thanks for the link! In my opinion that grammar doesn't have enough structure to benefit from a more structured representation than Attribute. Meta are a subset of attributes that are easier to work with in exchange for restricting yourself to a subset of the grammar that is common by convention. Use cases beyond that subset can parse what they need from Attribute.
Noted; I've been considering it but would use a __Nonexhaustive variant instead of waiting because it is effectively the same thing but stable.
Centril commentedon Aug 3, 2019
It's sort of the point of rust-lang/rust#57367 (comment) to change the convention (which mainly exists due to language limitations), e.g.:
#[serde(bound = "T: MyTrait")]#[serde(default = "Priority::lowest")]#[proptest(value = "None")]...into something better (which notably does not embed strings into the EDSL):
#[serde(bound(T: MyTrait))]#[serde(default(Priority::lowest))]#[proptest(value(None))]The way I'd do it is to be more lazy about
MetaList, expose:and then add a way to convert
MetaParenstoMetaList.dtolnay commentedon Aug 3, 2019
It ends up not being a net benefit. Once you've accounted for formats like
#[serde(default = Priority::Low, rename = "pri")], there ends up being so little generalizable structure to attributes that manipulating them as Meta is no longer any easier than writing the parser without Meta. This isn't a reflection of your MetaParens suggestion being bad; instead it reflects how well suited the Parse trait already is to handling such things. So while we could lazify and complicate Meta to fit 95% of use cases with a user experience that is 0-10% easier than the Parse trait, the current tradeoff fits 85% of use cases with a user experience that is substantially simpler.alexcrichton commentedon Aug 5, 2019
Thanks for championing this @dtolnay, this all sounds great to me!
There's two things I was wondering about as well:
I understand the need for this but if this were applied to serde, for example, it'd be pretty disruptive. As a massively used dependency it seems like we should try to bend over backwards pretty hard to see if we can avoid doing breaking changes for as long as possible.
Would it be possible to make all the enums of syn non-exhaustive and still preserve the basic ergonomics of what we have today? For example folds would still work, matches would have to return errors but that seems ok, and otherwise I'm not sure how too too disruptive this would be otherwise.
I suspect though that this has been thought about, so I'm curious to hear sort of what y'all have been thinking about this.
Why not 1.32.0? (being able to use the 2018 edition seems like it'd be nice?)
dtolnay commentedon Aug 5, 2019
This is true but it's only because serde appears in the public API of so many libraries. By contrast there are almost no libraries with syn in the public API, basically synstructure and a small handful of others. A lot of crates depend on syn but those are all proc macros with only macros in the API where a syn upgrade can be done transparently.
Analyzing changes from past releases, having a policy of non-exhaustive everything would not noticeably reduce the rate at which language changes beyond the add-a-variant variety stack up.
We will be using 2018 edition with 1.31.
alexcrichton commentedon Aug 5, 2019
Ah ok, that's a good point that it's not just new variants but tweaks to existing ones. If that's the case I think that there's no choice but to plan for eventual new breaking releases.
This point is moot, but although I agree that it's less pressing because
synisn't in the public API it's arguably still 'just as disruptive' in the sense that there will be a lot of effort necessary to upgrade parsers and avoid compiling 5 versions ofsynin one crate graph eventually. This work can all largely happen independently because there's no public API dependencies though.Oops, my mistake!
dtolnay commentedon Aug 12, 2019
I released 1.0.0-rc4 and don't have any further changes planned, so if nothing else comes up then this will be the release going out this week, likely Tuesday.
dtolnay commentedon Aug 13, 2019
https://github.com/dtolnay/syn/releases/tag/1.0.0
Merge #5
Merge #5
Merge #5